%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%{!?tcl_version: %global tcl_version %(echo 'puts $tcl_version' | tclsh)}
%{!?tcl_sitearch: %global tcl_sitearch %{_libdir}/tcl%{tcl_version}}

Name:          xapian-bindings
Version:       1.4.13
Release:       1%{?dist}
Summary:       Bindings for the Xapian Probabilistic Information Retrieval Library

License:       GPLv2+
URL:           http://www.xapian.org/
Source0:       http://www.oligarchy.co.uk/xapian/%{version}/%{name}-%{version}.tar.xz

# Only build py3 support on Fedora and el8
%if 0%{?rhel} > 7 || 0%{?fedora} > 28
%define with_py3 1
%else
%define with_py3 0
%endif

%if 0%{?rhel} > 7 || 0%{?fedora} > 30
%define with_py2 0
%else
%define with_py2 1
%endif

BuildRequires: gcc gcc-c++
BuildRequires: libuuid-devel
%if 0%{?with_py2}
BuildRequires: python2-devel python2-setuptools python3-sphinx
%endif
%if 0%{?with_py3}
BuildRequires: python3-devel python3-setuptools python3-sphinx
%endif
BuildRequires: ruby ruby-devel rubygems rubygem-rdoc rubygem-json
BuildRequires: tcl-devel
BuildRequires: xapian-core-devel
BuildRequires: zlib-devel

# Filter private-shared-object-provides
%{?filter_setup}

%description
Xapian is an Open Source Probabilistic Information Retrieval Library. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
files needed for scripts which use Xapian.

%if 0%{?with_py2}
%package -n python2-xapian
%{?python_provide:%python_provide python2-xapian}
%{?python_provide:%python_provide python2-xapian-bindings}
# Remove before F30
Provides: %{name}-python = %{version}-%{release}
Provides: %{name}-python%{?_isa} = %{version}-%{release}
Obsoletes: %{name}-python < %{version}-%{release}
Summary:       Files needed for developing Python scripts which use Xapian
Requires:      %{name} = %{version}-%{release}
%{?python_provide:%python_provide python2-xapian}

%description -n python2-xapian
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
files needed for developing Python scripts which use Xapian.
%endif

%if 0%{?with_py3}
%package -n python3-xapian
Summary:       Python 3 bindings for Xapian
Requires:      %{name} = %{version}-%{release}
%{?python_provide:%python_provide python3-xapian}

%description -n python3-xapian
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
bindings needed for developing Python3 scripts which use Xapian.
%endif

%package ruby
Summary:       Files needed for developing Ruby scripts which use Xapian
Requires:      %{name} = %{version}-%{release}
Requires:      ruby-libs

%description ruby
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
files needed for developing Ruby scripts which use Xapian

%package -n tcl-xapian
Summary:       Files needed for developing TCL scripts which use Xapian
Requires:      %{name} = %{version}-%{release}

%description -n tcl-xapian
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
files needed for developing TCL scripts which use Xapian

%prep
%setup -q

# There is no sphinx.main in Sphinx 2
sed -i 's/sphinx\.main/sphinx.cmd.build.main/g' $(grep -r 'sphinx\.main' -l)
sed -i 's/import sphinx/import sphinx.cmd.build/g' $(grep -r 'import sphinx' -l)

# Trick Python 2 to build docs by Python 3
sed -i 's/$PYTHON2 -c '"'"'import sphinx/python3 -c '"'"'import sphinx/' configure configure.ac
sed -i 's/PYTHONPATH=..:$$PYTHONPATH $(OSX_SIP_HACK_ENV) $(PYTHON2)/PYTHONPATH=..:$$PYTHONPATH $(OSX_SIP_HACK_ENV) python3/' python/Makefile.am python/Makefile.in

%build
%if 0%{?with_py3}
export PYTHON3_LIB=%{python3_sitelib}
%endif
export RUBY_LIB=%{ruby_vendorlibdir}
export RUBY_LIB_ARCH=%{ruby_vendorarchdir}

%configure \
%if 0%{?with_py2}
       %{?with_py2:--with-python} \
%endif
%if 0%{?with_py3}
       %{?with_py3:--with-python3} \
%endif
       --with-ruby --with-tcl

make %{?_smp_mflags} V=1

%install
make install DESTDIR=%{buildroot} INSTALL='install -p'

# Remove the dev docs, we pick them up below
rm -rf %{buildroot}%{_datadir}/doc/%{name}

%check
#make check

%files
%license COPYING
%doc AUTHORS NEWS README

%if 0%{?with_py2}
%files -n python2-xapian
%doc python/docs/examples
%{python2_sitearch}/xapian/
%endif

%if 0%{?with_py3}
%files -n python3-xapian
%{python3_sitelib}/xapian/
%endif

%files ruby
%{ruby_vendorarchdir}/_xapian.so
%{ruby_vendorlibdir}/xapian.rb

%files -n tcl-xapian
%{_libdir}/tcl%{tcl_version}/xapian%{version}/

%changelog
* Sun Oct 27 2019 Denis Arnaud <denis.arnaud_fedora@m4x.org> 1.4.13-1
- Initial build

